(define (length>1? a) (> (length a) 1))
(define (compose f g) (lambda(x) (f (g x))))

(define (profile name)
  (and name
      (woo-catch
          (lambda() (woo-read-first (string-append "/profile/" (sure-string name))))
          (lambda(reason) #f))))

;;try to expand one url to multiple items
(define (expand-url name)
  (define-operation all-matches)
  (let ((variants (all-matches (from-context 'atlas) (sure-symbol name))))
    ;;rollback if length equal to 1, otherwise we can drop parameters, user gives to us
    (if (length>1? variants) variants (list name))))

(define (expand-profile name)
  (define-operation next-url-of (lambda args name))
  (delete-duplicates
   (map (compose ->string next-url-of) (expand-url name))))

(define (get-modules profile)
  (or (and (pair? profile)
           (append-map expand-profile (string-cut (woo-get-option profile 'acc-modules) #\;)))
   '()))

(define (get-name profile)
  (and profile (woo-get-option profile 'acc-caption #f)))

(define (read-description item)
  (define-operation params-of)
  (or (and-let* ((path ((from-context 'atlas) item)))
         (woo-get-option (cons #f (params-of path)) 'acc-description #f))
      (->string item)))

;profile data
(define profile-short-name (make-cell #f))
(define profile-full-name (make-cell #f))
(define profile-modules (make-cell #f))
(define profile-system? (make-cell #f))
(define profile-translation (make-cell #f))

;profile loading
(define (load-profile name)
  (let ((pr (profile name)))
    (cell-set! profile-system? (string=? (woo-get-option pr 'acc-type) "system"))
    (cell-set! profile-translation (woo-get-option pr 'acc-translation #f))
    (cell-set! profile-short-name name)
    (cell-set! profile-modules (or (get-modules pr) '() ))
    (cell-set! profile-full-name (get-name pr))))
